#include "testApp.h"
#include "ofGraphics.h"
#include "ofConstants.h"
#include "ofAppRunner.h"

//--------------------------------------------------------------
void testApp::setup(){
    ofBackground(0,0,0);
    //ofBackground(255,255,255);
ofSetVerticalSync(true);
    ofSetFrameRate(24);

ofNoFill();

    ofEnableSmoothing();
    ofEnableAlphaBlending();
    for (int i=0; i<512;i++)
    {
        numero_cachos[i]=ofRandom(20, 50);
    }


     for (int j=0; j<512; j++){

        value[j]=0;



    }

 musica.loadSound("musica.mp3");

    musica.play();


}

//--------------------------------------------------------------
void testApp::update(){

    float signo;
  puntero=ofSoundGetSpectrum(512);
    for (int j=0; j<512; j++){

        value[j]=(*puntero*5000)+(360*(j/512));

        signo=ofRandomf();

        //if (signo<0){value[j]=-1*value[j];};
        puntero++;



    }
posicion=musica.getPosition();
angulo_posicion=posicion*360;
}

//--------------------------------------------------------------
void testApp::draw(){

    float angulo, angulo_inicial, angulo_total, radio;
    float suma_espacios;
    float radius, anchus;
    float red, green, blue,alfa;
    red=243; blue=21;alfa=100;
    ofFill();
    ofEnableSmoothing();
    ofSetLineWidth (1);

  ofSetColor(255,255,255,150);
        //ofSetColor(50,50,255,150);
    float resolucion=1000, x, y, ancho=8;
    x=ofGetWidth()/2;
    y=ofGetHeight()/2;

    for (int i=10; i<300; i=i+10){
        radio=i;
        suma_espacios=(5/radio)*numero_cachos[i];
        angulo=(360-suma_espacios)/numero_cachos[i];

         angulo_inicial=(i*2)+value[i];
         radius=radio;//+(value[i])*.05;
        anchus=ancho;//-(value[i]*0.05);
        green=230-(value[i]*0.8);
            //ofSetColor(0,125,i/2);
            alfa=30+(value[i]*0.8);
for (int j=0;j<numero_cachos[i];j++)
               {
                arco (resolucion, angulo, angulo_inicial, anchus, radius,x,y,red,green, blue,alfa);
                angulo_inicial=angulo + angulo_inicial + 5;
               }


               }
ofSetColor(red, green, blue,80);
ofRect(10, (y*2)-20, ofGetWidth()-30, 8);
ofSetColor(red,green,blue,150);
ofRect(10, (y*2)-20, ((ofGetWidth()-40)*posicion)+10, 8);

//arco (resolucion, angulo_posicion, 0, 70, 690,x,y,255,255, 255,255);
}

//--------------------------------------------------------------


void testApp::arco (float res, float ang, float ang_inicial, float ancho, float radius, float centroX, float centroY, float r, float g, float b, float alf){




    float angulo_rad;
    float angle;
    float pasos_arco;
    float pasos_iniciales;




     float angulo_inicial_rad;

      ofSetColor(r,g,b,alf);

float resolucion_paso=(2*PI)/res;//resolucion del arco

    angulo_rad=((2*PI)/360)*ang;
    angulo_inicial_rad=((2*PI)/360)*ang_inicial;//conversiones a radianes


    pasos_iniciales=angulo_inicial_rad/resolucion_paso;

    pasos_arco=(angulo_rad/resolucion_paso)+pasos_iniciales;


ofBeginShape();

for(int i = pasos_iniciales; i < pasos_arco; i++) {
angle = (i*resolucion_paso);
 ofVertex(centroX + (cos(angle) * radius), centroY + (sin(angle) * radius));
}

for(int i = pasos_arco; i > pasos_iniciales; i--) {
angle = (i*resolucion_paso);
 ofVertex(centroX + (cos(angle) * (radius-ancho)), centroY + (sin(angle) * (radius-ancho)));
}

ofEndShape(true);


}


//--------------------------------------------------------------
void testApp::keyPressed(int key){

}

//--------------------------------------------------------------
void testApp::keyReleased(int key){

}

//--------------------------------------------------------------
void testApp::mouseMoved(int x, int y ){

}

//--------------------------------------------------------------
void testApp::mouseDragged(int x, int y, int button){

}

//--------------------------------------------------------------
void testApp::mousePressed(int x, int y, int button){
 if (!musica.getIsPlaying()){musica.play();}
    if (mouseY>ofGetHeight()-20 & mouseY<(ofGetHeight()-12) & mouseX>10 & mouseX<ofGetWidth()-30)
    {float marca=ofNormalize(mouseX, 10, ofGetWidth()-40);
     musica.setPosition(marca);
    }


}

//--------------------------------------------------------------
void testApp::mouseReleased(int x, int y, int button){

}

//--------------------------------------------------------------
void testApp::windowResized(int w, int h){

}

